#include "color.h"

//Private

int Color::hexCharToInt(char hex) {
    if (hex >= 'A')
        hex -= 'A'-10;
    else
        hex -= '0';
    return hex;
}

//Public

Color::Color()
{
    redVal = 0;
    greenVal = 0;
    blueVal = 0;
}

Color::Color(int red, int green, int blue)
{
    redVal = red;
    greenVal = green;
    blueVal = blue;
}

Color::Color(std::string rgbString)
{
    if (rgbString.size() == 6) {
        const char * rgb = rgbString.c_str();
        redVal = hexCharToInt(rgb[0]) * 16 + hexCharToInt(rgb[1]);
        greenVal = hexCharToInt(rgb[2]) * 16 + hexCharToInt(rgb[3]);
        blueVal = hexCharToInt(rgb[4]) * 16 + hexCharToInt(rgb[5]);
    } else {
        redVal = 0;
        greenVal = 0;
        blueVal = 0;
    }
}

void Color::setRGB(float r, float g, float b){
    redVal=r;
    greenVal=g;
    blueVal=b;
}

int Color::red() const{
    return redVal;
}

int Color::green() const {
    return greenVal;
}

int Color::blue() const {
    return blueVal;
}
