#include "gcurve.h"

namespace GraphicsObjects {

    GCurve::GCurve(std::string name, Color * color) : GObject(name, color)
    {
    }

    GCurve::GCurve(std::string name, std::list<Point*> points, Color * color) : GObject(name, color)
    {
        GCurve::points = points;
    }

    bool GCurve::clip() {
        return clip(DEFAULT_ACCURACY);
    }

    bool GCurve::clip(float accuracy) {
        std::list<Point*> generatedPoints = generatePoints(accuracy);
        std::list<Point*>::iterator it = generatedPoints.begin();

        points.clear();
        Point * p1 = *it;
        Point * p2;
        it ++;

        while(it != generatedPoints.end()){
            p2 = *it;

            std::list<Point*> clippedLine = clipLine(p1->copy(), p2->copy());
            points.splice(points.end(), clippedLine);

            p1 = p2;
            it ++;
        }

        return points.size() > 0;
    }

} // namespace GraphicsObjects
