#include "gline.h"

namespace GraphicsObjects {

    GLine::GLine(std::string name, Point * p1, Point * p2, Color * color) : GObject(name, color)
    {
        add(p1);
        add(p2);
    }

    GLine * GLine::copy() {
        Point * p1 = (*points.begin())->copy();
        Point * p2 = (*(++points.begin()))->copy();
        return new GLine(name, p1, p2, color);
    }

    std::string GLine::type(){
        return "Line";
    }

    bool GLine::clip() {
        Point * p1 = (*points.begin())->copy();
        Point * p2 = (*(++points.begin()))->copy();

        points = clipLine(p1, p2);

        return points.size() == 2;
    }

} // namespace GraphicsObjects
