#ifndef GOBJECT_H
#define GOBJECT_H

#include "definitions.h"
#include "point.h"
#include "edge.h"
#include "color.h"

namespace GraphicsObjects {

    class GObject
    {
    public:
        std::list<Point*> points;
        std::string name;
        Color * color;

        GObject();
        GObject(std::string name);
        GObject(std::string name, Color * color);
        ~GObject();
        virtual GObject * copy() = 0;
        void add(float x, float y, float z);
        void add(Point * p);
        Point* center();
        std::list<Point*> getPoints();
        std::list<Point*> clipLine(Point * p1, Point * p2);
        virtual std::string type() = 0;
        virtual bool clip() = 0;
        std::string toString();
        std::string toStringOfPoints();
    };

} // namespace GraphicsObjects

#endif // GOBJECT_H
