#include "gpoint.h"

namespace GraphicsObjects {

    GPoint::GPoint(float x, float y, float z) : GObject()
    {
        add(new Point(x, y, z));
    }

    GPoint::GPoint(std::string name, Point * point, Color * color) : GObject(name, color)
    {
        add(point);
    }

    GPoint * GPoint::copy() {
        Point * p = (*points.begin())->copy();
        return new GPoint(name, p, color);
    }

    std::string GPoint::type(){
        return "Point";
    }

    bool GPoint::clip() {
        return ((*points.begin())->x > 1) || ((*points.begin())->x < -1)
                ||((*points.begin())->y > 1) || ((*points.begin())->y < -1)
                ||((*points.begin())->z > 1) || ((*points.begin())->z < -1) ? false:true;
    }

    Point * GPoint::point() {
        return *points.begin();
    }

} // namespace GraphicsObjects
