#include "gpolygon.h"

namespace GraphicsObjects {

    GPolygon::GPolygon(std::string name, std::list<Point*> points, Color * color) : GObject(name, color)
    {
        fill = false;
        GPolygon::points = points;
    }

    GPolygon::GPolygon(std::string name, std::list<Point*> points, Color * color, bool fill) : GObject(name, color)
    {
        GPolygon::fill = fill;
        GPolygon::points = points;
    }

    GPolygon * GPolygon::copy() {
        std::list<Point*> pointsCopy;
        std::list<Point*>::iterator pointsIt;
        for (pointsIt = points.begin(); pointsIt != points.end(); pointsIt++) {
            pointsCopy.push_back((*pointsIt)->copy());
        }
        return new GPolygon(name, pointsCopy, color, fill);
    }

    std::string GPolygon::type(){
        return "Polygon";
    }

    bool GPolygon::clip() {
        //TODO
        bool visible = false;
        std::list<Point*>::iterator it = points.begin();
        Point * p1 = *it;
        Point * p2;
        it++;
        while(it!=points.end()){
            p2 = (*it);
/*
            if ((p1out&&!p2out)||(!p1out&&p2out)){
                std::list<Point*> tmp = getPointsCliped(p1,p2);
                Point * newp;
                if (p1out)
                    newp = tmp.front();
                else
                    newp = tmp.back();
                points.insert(it,newp);
            }
*/
            std::list<Point*> tmp = clipLine(p1,p2);
            if (tmp.size()==2){
                Point * tmpp1=NULL;
                Point * tmpp2=NULL;

                tmpp1=tmp.front();
                tmpp2=tmp.back();

                if (p1->x!=tmpp1->x || p1->y!=tmpp1->y){
                    points.insert(it,tmpp1);
                }
                if (p2->x!=tmpp2->x || p2->y!=tmpp2->y){
                    points.insert(it,tmpp2);
                }
            }
            it++;
            p1 = p2;
        }

        std::list<Point*> tmp = clipLine(points.back(),points.front());
        if (tmp.size()==2){
            Point * pp1=points.back();
            Point * pp2=points.front();

            Point * tp1=tmp.front();
            Point * tp2=tmp.back();
            if (points.back())
            if (pp1->x!=tp1->x || pp1->y!=tp1->y)
                points.push_back(tp1);
            if (pp2->x!=tp2->x || pp2->y!=tp2->y)
                points.push_back(tp2);
        }

        for(it=points.begin();it!=points.end();it++){
            p1 = *it;
            bool p1out = (p1->x>1)
                         ||(p1->x<-1)
                         ||(p1->y>1)
                         ||(p1->y<-1);
            if (p1out){
                if (p1->x>1)
                    p1->x=1;
                if (p1->x<-1)
                    p1->x=-1;
                if (p1->y>1)
                    p1->y=1;
                if (p1->y<-1)
                    p1->y=-1;
            }
            else
                visible = true;
        }
        return visible;
    }

} // namespace GraphicsObjects
