#ifndef GUI_H
#define GUI_H

#include <QMainWindow>
#include <QLine>
#include <QGraphicsScene>
#include <QGraphicsView>
#include <QPainter>
#include <QPaintEngine>
#include <QPaintDevice>
#include <QtGui/QtGui>
#include <QRectF>
#include "world.h"
#include "window.h"
#include "definitions.h"
#include "xmlparser.h"

namespace Ui {
    class gui;
}

class gui : public QMainWindow {
    Q_OBJECT
public:
    gui(QWidget *parent = 0);
    ~gui();

protected:
    void changeEvent(QEvent *e);
    void resizeEvent(QResizeEvent *e);

private:
    Ui::gui *ui;
    QGraphicsScene *scene;
    Window * window;
    World * world;
    void redraw();

private slots:
    void on_actionSave_triggered();
    void on_actionOpen_triggered();
    void on_CurvedSurfaceAdd_clicked();
    void on_WireframeAdd_clicked();
    void on_Navigateback_clicked();
    void on_Navigatefront_clicked();
    void on_WireframeAddVertex_clicked();
    void on_WireframeAddEdge_clicked();
    void on_BSplineAdd_clicked();
    void on_BezierAdd_clicked();
    void on_BSplineAddPoint_clicked();
    void on_BezierAddPoint_clicked();
    void on_Changecolor_clicked();
    void on_Translation_clicked();
    void on_Scale_clicked();
    void on_Rotate_clicked();
    void on_PolygonAddPoint_clicked();
    void on_PolygonAdd_clicked();
    void on_Zoomout_clicked();
    void on_Zoomin_clicked();
    void on_Rotatewindow_clicked();
    void on_Navigateleft_clicked();
    void on_Navigateright_clicked();
    void on_Navigatedown_clicked();
    void on_Navigateup_clicked();
    void on_LineAdd_clicked();
    void on_PointAdd_clicked();
};

#endif // GUI_H
