#include "point.h"
#include "world.h"
#include "transformations.h"

#ifndef WINDOW_H
#define WINDOW_H

class Window
{
public:
    World * world;
    std::list<GObject*> objects;

    float width;
    float height;
    float distanceFromProjectionCenter;
    float depth;
    GPoint * center;
    GPoint * vpn;
    GPoint * vpu;

    Window(World * world, float width, float height, float depth, float distanceFromProjectionCenter);
    void navigate(Axis axis, float rate);
    void zoom(float rate);
    void rotate(float angle);
    void rotate(Axis axis, float angle);
    void refresh();
    std::list<GObject*> getViewportObjectsClipped(Point * vpMin, Point * vpMax, float curveAccuracy);
    std::list<GObject*> getViewportObjects(Point * vpMin, Point * vpMax);

    void setAtributes(Point * cop, Point * vpn, Point * vpu, Point * wmin, Point * wmax);
};

#endif // WINDOW_H
