#ifndef XMLPARSER_H
#define XMLPARSER_H

#include <QFile>
#include <QXmlQuery>
#include <QXmlResultItems>
#include "definitions.h"
#include "world.h"
#include "window.h"

namespace XmlParser {
    void openFile(std::string fileName, World * world, Window * window);

    void setWindowAttributes(QXmlQuery query, QXmlItem * shapeItem, Window * window);
    Point * constructPoint(QXmlQuery query, QXmlItem * shapeItem);
    Edge * constructEdge(QXmlQuery query, QXmlItem * shapeItem, std::list<Point*> vertices);
    GPoint * constructPoint(QXmlQuery query, QXmlItem * shapeItem, World * world);
    GLine * constructLine(QXmlQuery query, QXmlItem * shapeItem, World * world);
    GPolygon * constructPolygon(QXmlQuery query, QXmlItem * shapeItem, World * world);
    GBSpline * constructBSplineCurve(QXmlQuery query, QXmlItem * shapeItem, World * world);
    GBezier * constructBezierCurve(QXmlQuery query, QXmlItem * shapeItem, World * world);
    GWireframe * constructWireframe(QXmlQuery query, QXmlItem * shapeItem, World * world);
    GBSplineSurface * constructBSplineSurface(QXmlQuery query, QXmlItem * shapeItem, World * world);
}

#endif // XMLPARSER_H
